//import your libraries. 
import de.bezier.data.sql.*;
import java.sql.*;

//THIS is a simple sketch that saves the result of a MySQL query as a text file so that we can load into a visualization sketch to avoid having to query the server every time we start it.  
//It will make things run much faster so I suggest doing this whenever you've decided on the exact query you want to use for a visualization.  

MySQL msql;
String[] textArray = new String[1];
String DL = "^|^"; //the DELIMITER

void setup() {
    // connecting to the TANGO database
    msql = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
    if ( msql.connect() )
    { 
      String TheQuery="select FLOOR(deweyClass/10)*10 subgroup, title, cout, cin, (TIMESTAMPDIFF(DAY, cout, cin)) duration from spl0.inraw where (deweyClass <> 'null' OR deweyClass <> NULL) and itemtype = 'jcbk' and (TIMESTAMPDIFF(DAY, cout, cin)) > 0 and year(cout) >= 2009 and year(cin) <= 2011 and FLOOR(deweyClass/10)*10 in ('90','160','250','310','470','540','670','760','870','990');";
      
          println(TheQuery);
          msql.query( TheQuery);
          println("running");
          textArray[0] = TheQuery;
          while( msql.next() ){
              //always use msql.getString instead of getInt or getFloat, because we're just saving this to a text file.  
              //We'll cast them as floats or ints later when we import it into our actual visualization. 
              println("running");
              ResultSet rs = msql.result;
              int numOfColumns = 0;
              String result = "";

              try{
                ResultSetMetaData rsmd = rs.getMetaData();
                numOfColumns = rsmd.getColumnCount();
              }
              catch(Exception e){
                println("error");
              }              
              for(int i=1; i<= numOfColumns; i++){
                if(i != numOfColumns)
                  result = result + msql.getString(i) + DL;
                else
                  result += msql.getString(i);
              }              
              textArray = append(textArray, result);             
              //textArray = append(textArray, msql.getString(1) + DL + msql.getString(2)); //separate each column by the "^^" delimiter so that we can parse the file later on.  
          }     
     }
    else
    {
      println(" connection failed !");
    }
    saveStrings("adultData.txt", textArray);
    println("Data saved");
}

void draw() {
  exit();
}


/* This is how you can retrieve the data.  Put this code into your visualization file probably in the setup.  Make sure the savedData.txt file is also in its folder:
 
  String savedData[] = loadStrings("savedData.txt");
  println("QUERY: " + savedData[0]);
  for (int i=1; i < savedData.length; i++) {
    
    String temp[] = split(savedData[i], "^^");
    transactionsPerHour[Integer.parseInt(temp[0])] = Integer.parseInt(temp[1]);
    
    //transactionsPerHour[msql.getInt(1)] = msql.getInt(2);
  }   
  
*/




